"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.safeSetTimeout = safeSetTimeout;
exports.safeSetInterval = safeSetInterval;
/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

/**
 * Wrapper around setTimout which (in node) unrefs the returned timer to avoid
 * wedging the process open unexpectedly.
 * @param {Mixed} args
 * @protected
 * @returns {Timer|Number}
 */
function safeSetTimeout() {
  var timer = setTimeout.apply(undefined, arguments);

  if (timer.unref) {
    timer.unref();
  }

  return timer;
}

/**
 * Wrapper around setTimout which (in node) unrefs the returned timer to avoid
 * wedging the process open unexpectedly.
 * @param {Mixed} args
 * @protected
 * @returns {Timer|Number}
 */
function safeSetInterval() {
  var interval = setInterval.apply(undefined, arguments);

  if (interval.unref) {
    interval.unref();
  }

  return interval;
}
//# sourceMappingURL=index.js.map
