# @webex/common

[![standard-readme compliant](https://img.shields.io/badge/readme%20style-standard-brightgreen.svg?style=flat-square)](https://github.com/RichardLitt/standard-readme)

> Common functions for the Cisco Webex JS SDK.

- [Install](#install)
- [Usage](#usage)
- [Contribute](#contribute)
- [Maintainers](#maintainers)
- [License](#license)

## Install

```bash
npm install --save @webex/common
```

## Usage

Since this package exports common functions for the Cisco Webex JS SDK, many of its exports are applicable only within that SDK.

General-use exports include

- [capped-debounce](./src/capped-debounce.js)
- [defer](./src/defer.js)
- [deprecated](./src/deprecated.js)
- [exception](./src/exception.js)
- [one-flight](./src/one-flight.js)
- [tap](./src/tap.js)

## Maintainers

This package is maintained by [Cisco Webex for Developers](https://developer.webex.com/).

## Contribute

Pull requests welcome. Please see [CONTRIBUTING.md](https://github.com/webex/webex-js-sdk/blob/master/CONTRIBUTING.md) for more details.

## License

© 2016-2019 Cisco and/or its affiliates. All Rights Reserved.
