/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

/**
 * Helper to ensure we have registered with wdm
 * before calling any internal-plugin-conversations functions
 * @param {Object} webex
 * @returns {Promise}
 */
export default async function ensureConvoAvailability(webex) {
  if (webex.internal.device.services.conversationServiceUrl) {
    return Promise.resolve();
  }

  return webex.internal.device.register();
}

