'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.escape = escape;
exports.escapeSync = escapeSync;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

var escapeMe = /(<|>|&)/g;

// escape and escapeSync probably don't both need to exist, but it seemed like a
// good idea in case we ever want to for the future.

/**
 * Escapes HTML
 * @param {[type]} html
 * @returns {[type]}
 */
function escape(html) {
  return new _promise2.default(function (resolve) {
    return resolve(escapeSync(html));
  });
}

/**
 * Synchronously escape HTML
 * @param {[type]} html
 * @returns {[type]}
 */
function escapeSync(html) {
  return html.replace(escapeMe, entityReplacer);
}

/**
 * @param {string} char
 * @private
 * @returns {string}
 */
function entityReplacer(char) {
  switch (char) {
    case '<':
      return '&lt;';
    case '>':
      return '&gt;';
    case '&':
      return '&amp;';
    default:
      return char;
  }
}
//# sourceMappingURL=html-base.js.map
