'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _loggerProxy = require('../logs/logger-proxy');

var _loggerProxy2 = _interopRequireDefault(_loggerProxy);

var _loggerConfig = require('../logs/logger-config');

var _loggerConfig2 = _interopRequireDefault(_loggerConfig);

var _parameter = require('../errors/parameter');

var _parameter2 = _interopRequireDefault(_parameter);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TriggerProxy = {};

TriggerProxy.trigger = function (instance, scope, trigger, payload) {
  if (!instance || !instance.trigger) {
    throw new _parameter2.default('Instance to trigger from must be defined and have a trigger function.');
  }

  _loggerProxy2.default.logger.debug(_util2.default.getScopeLog(scope) + 'event#' + trigger + (_loggerConfig2.default.verboseEvents ? ' -- ' + _util2.default.getEventLog(payload) : ''));

  return instance.trigger(trigger, payload);
};

exports.default = TriggerProxy;
//# sourceMappingURL=trigger-proxy.js.map
