'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _httpCore = require('@webex/http-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @class
 */
/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

var ResponseLoggerInterceptor = function (_Interceptor) {
  (0, _inherits3.default)(ResponseLoggerInterceptor, _Interceptor);

  function ResponseLoggerInterceptor() {
    (0, _classCallCheck3.default)(this, ResponseLoggerInterceptor);
    return (0, _possibleConstructorReturn3.default)(this, (ResponseLoggerInterceptor.__proto__ || (0, _getPrototypeOf2.default)(ResponseLoggerInterceptor)).apply(this, arguments));
  }

  (0, _createClass3.default)(ResponseLoggerInterceptor, [{
    key: 'onResponse',


    /**
     * @see Interceptor#onRequest
     * @param {Object} options
     * @param {HttpResponse} response
     * @returns {Object}
     */
    value: function onResponse(options, response) {
      var now = new Date();

      this.printResponseHeader(options, response);

      var logger = (0, _get3.default)(this, 'webex.logger', console);

      if (process.env.ENABLE_VERBOSE_NETWORK_LOGGING) {
        logger.info('timestamp (end): ', now.getTime(), now.toISOString());
        if (typeof response.body === 'string' || Buffer.isBuffer(response.body)) {
          logger.info('Response: ', 'Not printed, it`s probably a file');
        } else if ((0, _typeof3.default)(response.body) === 'object') {
          try {
            logger.info('Response: ', _util2.default.inspect((0, _omit3.default)(response.body, 'features'), { depth: null }));
          } catch (err) {
            logger.info('Response: ', '[Not Serializable]', err);
          }
        }
      }
      logger.info('\\**********************************************************************/');

      return response;
    }

    /**
     * @see Interceptor#onRequest
     * @param {Object} options
     * @param {Object} reason
     * @returns {Object}
     */

  }, {
    key: 'onResponseError',
    value: function onResponseError(options, reason) {
      var now = new Date();

      this.printResponseHeader(options, reason);

      var logger = (0, _get3.default)(this, 'webex.logger', console);

      if (process.env.ENABLE_VERBOSE_NETWORK_LOGGING) {
        logger.info('timestamp (end): ', now.getTime(), now.toISOString());
        try {
          logger.error('Response: ', _util2.default.inspect(reason.body, { depth: null }));
        } catch (err) {
          logger.error('Response: ', reason.body);
        }
      }
      logger.info('\\**********************************************************************/');

      return _promise2.default.reject(reason);
    }

    /**
     * Prints the basic header
     * @param {Object} options
     * @param {HttpResponse|WebexHttpError} response
     * @returns {undefined}
     */

  }, {
    key: 'printResponseHeader',
    value: function printResponseHeader(options, response) {
      var logger = (0, _get3.default)(this, 'webex.logger', console);

      logger.info('Status Code:', response.statusCode);
      logger.info('WEBEX_TRACKINGID:', (0, _get3.default)(options, 'headers.trackingid') || (0, _get3.default)(response, 'headers.trackingid'));
      logger.info('Network duration:', options.$timings.networkEnd - options.$timings.networkStart);
      logger.info('Processing duration:', options.$timings.requestEnd - options.$timings.requestStart);
    }
  }], [{
    key: 'create',

    /**
     * @returns {ResponseLoggerInterceptor}
     */
    value: function create() {
      return new ResponseLoggerInterceptor({ webex: this });
    }
  }]);
  return ResponseLoggerInterceptor;
}(_httpCore.Interceptor);

exports.default = ResponseLoggerInterceptor;
//# sourceMappingURL=response-logger.js.map
