'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sortScope = sortScope;
exports.filterScope = filterScope;
/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

/**
 * sorts a list of scopes
 * @param {string} scope
 * @returns {string}
 */
function sortScope(scope) {
  if (!scope) {
    return '';
  }

  return scope.split(' ').sort().join(' ');
}

/**
 * sorts a list of scopes and filters the specified scope
 * @param {string} toFilter
 * @param {string} scope
 * @returns {string}
 */
function filterScope(toFilter, scope) {
  if (!scope) {
    return '';
  }

  return scope.split(' ').filter(function (item) {
    return item !== toFilter;
  }).sort().join(' ');
}
//# sourceMappingURL=scope.js.map
